package jcifs.auth.spnego;

public class InitiatorToken implements SpnegoToken {

    public static final int CREDENTIAL_DELEGATION = 0x01;

    public static final int MUTUAL_AUTHENTICATION = 0x02;

    public static final int REPLAY_DETECTION = 0x04;

    public static final int SEQUENCE_CHECKING = 0x08;

    public static final int ANONYMOUS_AUTHENTICATION = 0x10;

    public static final int CONFIDENTIALITY = 0x20;

    public static final int INTEGRITY = 0x40;

    private byte[] material;

    private String[] mechanisms;

    private int flags;

    private byte[] mic;

    public InitiatorToken() {
        this(null, null, 0, null);
    }

    public InitiatorToken(byte[] material, String[] mechanisms, int flags,
            byte[] mic) {
        setMaterial(material);
        setMechanisms(mechanisms);
        setFlags(flags);
        setMechanismListMIC(mic);
    }

    public String[] getMechanisms() {
        return mechanisms;
    }

    public void setMechanisms(String[] mechanisms) {
        this.mechanisms = mechanisms;
    }

    public int getFlags() {
        return flags;
    }

    public void setFlags(int flags) {
        this.flags = flags;
    }

    public boolean getFlag(int flag) {
        return (getFlags() & flag) != 0;
    }

    public void setFlag(int flag, boolean value) {
        setFlags(value ? (getFlags() | flag) :
                (getFlags() & (0xffffffff ^ flag)));
    }

    public byte[] getMaterial() {
        return material;
    }

    public void setMaterial(byte[] material) {
        this.material = material;
    }

    public byte[] getMechanismListMIC() {
        return mic;
    }

    public void setMechanismListMIC(byte[] mic) {
        this.mic = mic;
    }

}
