package jcifs.auth.spnego;

public class TargetToken implements SpnegoToken {

    public static final int ACCEPT_COMPLETED = 0;

    public static final int ACCEPT_INCOMPLETE = 1;

    public static final int REJECTED = 2;

    private byte[] material;

    private String mechanism;

    private int result;

    private byte[] mic;

    public TargetToken() {
        this(null, null, ACCEPT_INCOMPLETE, null);
    }

    public TargetToken(byte[] material, String mechanism, int result,
            byte[] mic) {
        setMaterial(material);
        setMechanism(mechanism);
        setResult(result);
        setMechanismListMIC(mic);
    }

    public int getResult() {
        return result;
    }

    public void setResult(int result) {
        this.result = result;
    }

    public String getMechanism() {
        return mechanism;
    }

    public void setMechanism(String mechanism) {
        this.mechanism = mechanism;
    }

    public byte[] getMaterial() {
        return material;
    }

    public void setMaterial(byte[] material) {
        this.material = material;
    }

    public byte[] getMechanismListMIC() {
        return mic;
    }

    public void setMechanismListMIC(byte[] mic) {
        this.mic = mic;
    }

}
