import jcifs.auth.TokenFactory;

import jcifs.auth.ntlm.Type1Token;
import jcifs.auth.ntlm.Type2Token;
import jcifs.auth.ntlm.Type3Token;

import jcifs.Config;
import jcifs.UniAddress;

import jcifs.smb.NtlmPasswordAuthentication;
import jcifs.smb.SmbSession;

public class test {

    public static void main(String[] args) throws Exception {
        String domain = args[0];
        String user = args[1];
        String password = args[2];
        String hostname = args[3];

        Config.setProperty("jcifs.smb.client.domain", domain);
        Config.setProperty("jcifs.smb.client.username", user);
        Config.setProperty("jcifs.smb.client.password", password);
        Config.setProperty("jcifs.netbios.hostname", hostname);

        TokenFactory tokenFactory = TokenFactory.getInstance();

        // client creates Type 1
        // create Type 1 token using defaults from jcifs.* properties
        Type1Token type1 = new Type1Token();
        byte[] material = tokenFactory.createMaterial(type1);
        // send material to server...
//------------------------------------------------------------------------------
        // server parses material to retrieve Type 1
        type1 = (Type1Token) tokenFactory.createToken(material);
        System.out.println("Server got Type 1 - " + type1);
        // create Type 2 token using defaults from jcifs.* properties and Type 1
        Type2Token type2 = new Type2Token(type1);
        UniAddress domainController =
                UniAddress.getByName(Type2Token.getDefaultDomain(), true);
        type2.setChallenge(SmbSession.getChallenge(domainController));
        material = tokenFactory.createMaterial(type2);
        // send material to client...
//------------------------------------------------------------------------------
        // client parses material to retrieve Type 2
        type2 = (Type2Token) tokenFactory.createToken(material);
        System.out.println("Client got Type 2 - " + type2);
        // create Type 2 token using defaults from jcifs.* properties and Type 2
        Type3Token type3 = new Type3Token(type2);
        material = tokenFactory.createMaterial(type3);
        // send material to server...
//------------------------------------------------------------------------------
        // server parses material to retrieve Type 3
        type3 = (Type3Token) tokenFactory.createToken(material);
        System.out.println("Server got Type 3 - " + type3);
        NtlmPasswordAuthentication credentials =
                new NtlmPasswordAuthentication(type3.getDomain(),
                        type3.getUser(), type3.getLMResponse(),
                                type3.getNTResponse());
        SmbSession.logon(domainController, credentials);
    }

}
